/*
 * Copyright 2020, gRPC Authors All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
@testable import GRPC
import XCTest

class RequestIDProviderTests: GRPCTestCase {
  func testUserDefined() {
    let provider = CallOptions.RequestIDProvider.userDefined("foo")
    XCTAssertEqual(provider.requestID(), "foo")
    XCTAssertEqual(provider.requestID(), "foo")
  }

  func testAutogenerated() {
    let provider = CallOptions.RequestIDProvider.autogenerated
    XCTAssertNotEqual(provider.requestID(), provider.requestID())
  }

  func testGenerator() {
    let provider = CallOptions.RequestIDProvider.generated {
      return "foo"
    }
    XCTAssertEqual(provider.requestID(), "foo")
  }
}
